<template>
  <div>
    <label class="categoryLabel" for="category">Category: </label>
    <select
      class="selectCategories"
      required
      id="category"
      v-model="category"
      @change="setCategory(category)"
    >
      <option value="0">Any category</option>
      <option
        v-for="category of categories"
        :value="category.id"
        :key="category.id"
      >
        {{ category.name }}
      </option>
    </select>
  </div>
</template>

<script>
import { mapMutations } from "vuex";

export default {
  name: "StartPageCategories",

  data() {
    return {
      categories: [],
      category: 0,
    };
  },

  created() {
    this.fetchCategories();
  },

  methods: {
    ...mapMutations(["setCategory"]),

    /**
     * Fetches all the available categories.
     */
    async fetchCategories() {
      const response = await fetch("https://opentdb.com/api_category.php");
      const data = await response.json();
      this.categories = data.trivia_categories;
    },
  },
};
</script>

<style>
.label {
  font-size: larger;
}

.selectCategories {
  width: 100%;
  margin: 0px;
  margin-bottom: 10px;
  padding: 5px;
  background-color: rgb(144, 199, 250);
  border: 1px solid rgb(45, 121, 192);
}
</style>